#include <ctime>
#include <iostream>
#include <vector>

using namespace std;

int modus, anzahlSchiffe, anzahlUboote, radiusBewegen, radiusSicht, radiusAngriff, breite, hoehe;

vector<string> feld, originalFeld;

struct boot {
	int x, y;

	bool bewege(int neuX, int neuY) {
		if (abs(neuX - x) * abs(neuX - x) + abs(neuY - y) * abs(neuY - y) > radiusBewegen) {
			return false;
		} else if (neuX < 0 || neuX >= breite || neuY < 0 || neuY >= hoehe) {
			return false;
		} else if (feld[neuY][neuX] == '#') {
			return false;
		} else {
			feld[neuY][neuX] = '#';
			x = neuX;
			y = neuY;
			return true;
		}
	}
};

void randomMoveUmEins(boot& b) {
	while (b.bewege(b.x + ((rand() % 3) - 1), b.y + ((rand() % 3) - 1)) == false);
}

int main() {
	srand(time(NULL));
	cin >> modus >> anzahlSchiffe >> anzahlUboote >> radiusBewegen >> radiusSicht >> radiusAngriff >> breite >> hoehe;
	originalFeld.resize(hoehe, string(breite, ' '));
	vector<boot> boote(modus == 0 ? anzahlSchiffe : anzahlUboote);

	int itBoot = 0;
	for (int i = 0; i < hoehe; ++i) {
		for (int j = 0; j < breite; ++j) {
			cin >> originalFeld[i][j];
			if (itBoot < boote.size() && originalFeld[i][j] == (modus == 0 ? 's' : 'd')) {
				boote[itBoot].x = j;
				boote[itBoot].y = i;
				cout << j << " " << i << endl;
				++itBoot;
			}
		}
	}

	feld = originalFeld;
	while (modus == 0) { //Spieler = Schiff
		//update map fast
		for (auto & schiff : boote) {
			feld[schiff.y][schiff.x] = originalFeld[schiff.y][schiff.x];
		}
		//Tote Schiffe loeschen und array bereitstellen
		int anzahlToteSchiffe;
		cin >> anzahlToteSchiffe;
		if (anzahlToteSchiffe < 0) {
			// game is finished
			break;
		}
		vector<boot> toteSchiffe(anzahlToteSchiffe);
		for (int i = 0; i < anzahlToteSchiffe; ++i) {
			int ignore;
			cin >> toteSchiffe[i].x >> toteSchiffe[i].y >> ignore >> ignore;
			for (int j = 0; j < boote.size(); ++j) {
				if (boote[j].x == toteSchiffe[i].x && boote[j].y == toteSchiffe[i].y) {
					boote.erase(boote.begin()+j);
				}
			}
		}
		//Code um Schiffe zu bewegen hier einfuegen
		for (auto & schiff : boote) {
			randomMoveUmEins(schiff);
		}
		//Output von Positionen
		for (int i = 0; i < boote.size();) {
			cout << "M " << boote[i].x << " " << boote[i].y << endl;
			if (originalFeld[boote[i].y][boote[i].x] == 'd') {
				boote.erase(boote.begin()+i); //goal reached
			} else {
				++i;
			}
		}
	}

	while (modus == 1) { //Spieler = Uboot
		//update map fast
		for (auto & uboot : boote) {
			feld[uboot.y][uboot.x] = originalFeld[uboot.y][uboot.x];
		}
		int sichtbareSchiffe;
		cin >> sichtbareSchiffe;
		if (sichtbareSchiffe < 0) {
			// game is finished
			break;
		}
		vector<boot> gegnerSchiffe(sichtbareSchiffe);
		for (int i = 0; i < sichtbareSchiffe; ++i) {
			cin >> gegnerSchiffe[i].x >> gegnerSchiffe[i].y;
		}
		for (auto & uboot : boote) {
			bool hatGeschossen = false;
			//Schiessen wenn moeglich
			for (auto & schiff : gegnerSchiffe) {
				if (abs(uboot.x - schiff.x) * abs(uboot.x - schiff.x) + abs(uboot.y - schiff.y) * abs(uboot.y - schiff.y) <= radiusAngriff) {
					cout << "A " << schiff.x << " " << schiff.y << endl;
					hatGeschossen = true;
					break; //nicht zweimal schiessen!
				}
			}
			//Sonst zufaellige Bewegung
			if (hatGeschossen == false) {
				randomMoveUmEins(uboot);
				cout << "M " << uboot.x << " " << uboot.y << endl;
			}
		}
	}
}

